/*****************************************************************************

This source code is made available to you under the terms of the Open
Development License.  This Package should be accompanied by a file that
contains the associated licensing terms.  If you are unable to find this file,
please refer to its location on the Internet at www.rocklyte.com/license.html.

******************************************************************************

###CLASS###
Name:      Else
Date:      May 2001
Version:   1.0
ID:        ID_ELSE
Category:  Command
Author:    Rocklyte Systems
Copyright: Rocklyte Systems (c) 2000-2001.  All rights reserved.
Short:     Used in conjuction with the If class to provide condition testing
           in the GUI.
Keywords:  if, else, condition, conditional, statement, test, compare, comparison

###DESCRIPTION###
<p>The Else class is a "dummy" complement to the If class as a means of
managing else conditions.  It only works when contained by an If object, which
must be loaded into the system statically.  Refer to the If class for further
information.</p>

###END###

*****************************************************************************/

/*****************************************************************************
** Else: Init
*/

static ERROR ELSE_Init(struct Else *Self, APTR Void)
{
   OBJECTPTR Owner;
   OBJECTID OwnerID;

   if ((OwnerID = GetOwner(Self))) {
      if (AccessObject(OwnerID, 1000, &Owner) IS ERR_Okay) {
         if (Owner->ClassID != ID_IF) {
            ReleaseObject(Owner);
            return(ObjectError(Self, ERH_Init, ERR_UnsupportedOwner));
         }
         ReleaseObject(Owner);
         return(ERR_Okay);
      }
      else return(ERR_Okay);
   }
   else return(ERR_Okay);
}
