#ifndef  MODULES_POINTER_H
#define  MODULES_POINTER_H

/*
**   pointer.h
**
**   (C) Copyright 2004 Rocklyte Systems.
**       All Rights Reserved.
*/

#ifndef  MAIN_H
#include <pandora/main.h>
#endif

#ifndef  GRAPHICS_POINTER_H
#include <pandora/graphics/pointer.h>
#endif

#define MODVERSION_POINTER ((FLOAT)1.0)

struct CursorInfo {
   LONG Width;         /* Maximum cursor width for custom cursors */
   LONG Height;        /* Maximum cursor height for custom cursors */
   LONG Flags;         /* Informative flag settings */
   WORD BitsPerPixel;  /* Preferred bits-per-pixel setting for custom cursors */
};

#define CRF_HARDWARE 0x00000001

/*****************************************************************************
** Function Table.
*/

#ifndef LOCAL_POINTER

struct PointerBase {
   ERROR (*SetCursor)(OBJECTID, LONG, LONG, STRING, OBJECTID, LONG);
   ERROR (*RestoreCursor)(LONG, OBJECTID);
   ERROR (*GetCursorPos)(LONG *, LONG *);
   ERROR (*SetCursorPos)(LONG, LONG);
   ERROR (*GetRelativeCursorPos)(OBJECTID, LONG *, LONG *);
   ERROR (*GetCursorInfo)(struct CursorInfo *, LONG);
   ERROR (*SetCustomCursor)(OBJECTID, LONG, struct Bitmap *, LONG, LONG, OBJECTID, LONG *);
   struct Pointer * (*AccessPointer)(void);
};

#define AccessPointer()             (PointerBase->AccessPointer())
#define GetCursorInfo(a,b)          (PointerBase->GetCursorInfo(a,b))
#define GetCursorPos(a,b)           (PointerBase->GetCursorPos(a,b))
#define GetRelativeCursorPos(a,b,c) (PointerBase->GetRelativeCursorPos(a,b,c))
#define RestoreCursor(a,b)          (PointerBase->RestoreCursor(a,b))
#define SetCursor(a,b,c,d,e,f)      (PointerBase->SetCursor(a,b,c,d,e,f))
#define SetCursorPos(a,b)           (PointerBase->SetCursorPos(a,b))
#define SetCustomCursor(a,b,c,d,e,f,g)  (PointerBase->SetCustomCursor(a,b,c,d,e,f,g))

#else

static struct Pointer * AccessPointer(void);
static ERROR GetCursorPos(LONG *, LONG *);
static ERROR GetRelativeCursorPos(OBJECTID, LONG *, LONG *);
static ERROR GetCursorInfo(struct CursorInfo *, LONG);
static ERROR RestoreCursor(LONG, OBJECTID);
static ERROR SetCursor(OBJECTID, LONG, LONG, STRING, OBJECTID, LONG *);
static ERROR SetCursorPos(LONG, LONG);
static ERROR SetCustomCursor(OBJECTID, LONG, struct Bitmap *, LONG, LONG, OBJECTID, LONG *);

#endif /* LOCAL_POINTER */

#define ReleasePointer(a)    (ReleaseObject(a))

#endif /* MODULES_POINTER_H */
